library(mnist)
library(gmodels)

#dowloading data
mnist <- download_mnist()


## preparing data
datatotal= as.matrix(mnist)
Label=datatotal[,ncol(datatotal)]
Label=as.numeric(Label)+1
datatotal=matrix(as.numeric(datatotal[,-ncol(datatotal)]),nrow=nrow(datatotal),byrow=F)
datatotal=cbind(Label,datatotal/255)
datatotal=matrix(as.numeric(datatotal), nrow=nrow(datatotal),byrow = F)



### creating training and test sets
ntotal=nrow(datatotal)
melange=sample.int(ntotal)
datamel=datatotal[melange,]
n0=floor(6/7*ntotal)
datatrain=datamel[1:n0,]
datatest=datamel[(n0+1):ntotal,]



###running WASN algorith!
K=10
thetatrainasn= WASN(datatrain,K=K)


##### Assignating clusters for test data
clustervec=rep(0,length(nrow(datatest)))
for (i in 1:nrow(datatest))
{
  phi=datatest[i,2:ncol(datatest)]
  p=exp(matrix(thetatrainasn$thetaw,byrow=T,ncol=ncol(datatest)-1)%*%(phi)-max(matrix(thetatrainasn$thetaw,byrow=T,ncol=ncol(datatest)-1)%*%(phi)))
  p=p/sum(p)
  clustervec[i]= which(p == max(p))
}

#### Warning! to run WASN algorithm, 1 has been added to labels

#### True class
TClass <- factor(datatest[,1]-1)

### Predicted class
PClass <- factor(clustervec-1)

###confusion matrix
tab <- c(table(TClass,PClass))
df <- data.frame(TClass, PClass, tab)


###Plot of the confusion matrix

library(ggplot2)


True=TClass
Predicted=PClass


ggplot(data = confusion_matrix2,
       mapping = aes(x = Predicted,
                     y = True)) +
  geom_tile(aes(fill = Freq)) +
  geom_text(aes(label = sprintf("%1.0f", Freq)), vjust = 1) +
  scale_fill_gradient(low = "blue",
                      high = "red")
